#include <basictypes.h>
#include <ucos.h>
#include "StopWatch.h"

#ifdef MOD5270B
#ifndef MOD5270
#define MOD5270
#endif
#endif


#if (defined MOD5270 || defined PK70 || defined SB70 )
#include "sim5270.h"
#elif (defined MOD5234 || defined CB34EX)
#include "sim5234.h"
#elif (defined MOD5272 || defined SB72 || defined SB72EX ) 
#include "sim5272.h"
#elif (defined MOD5282) 
#include "sim5282.h"
#elif (defined MOD5213) 
#include "sim5213.h"
#elif ( defined MCF5208 ) 
#include "sim5208.h"
#endif

volatile WORD PS;

void InitStopWatch( WORD Prescaler )
{
   StopClearStopWatch( );
   PS = Prescaler;
#if defined MOD5272
   sim.timer2.tmr = 0xFF01;   // Enable
   sim.timer2.trr = 0xFFFF;
#elif defined MOD5213
   sim.timer[1].dtmr = (0x0001 | (Prescaler<<8) );   // Enable
#else
   sim.timer[1].tmr = (0x0001 | (Prescaler<<8) );   // Enable
#endif
}
void StartStopWatch()
{
#if defined MOD5272
   sim.timer2.tmr |= 0x4;
#elif defined MOD5213
   sim.timer[1].dtmr |= 0x2;
#else
   sim.timer[1].tmr |= 0x2;
#endif

}

DWORD ReadStopWatch()
{
#if defined MOD5272
	if(0x2 & sim.timer2.ter)
   return (0x10000 | sim.timer2.tcn);
   return ( sim.timer2.tcn);
#elif defined MOD5213
   return sim.timer[1].dtcn;
#else
   return sim.timer[1].tcn;
#endif
}

double ReadTime()
{
	register DWORD CurrentCount  = ReadStopWatch();
   return ( (double)TIME_PER_CLK * (double)CurrentCount * (double)(PS + 1) );
}

void StopClearStopWatch()
{
#if defined MOD5272
   sim.timer2.tmr &= ~(0x4);
   sim.timer2.tcn = 0x0;
   sim.timer2.ter = 0x3;
#elif defined MOD5213
   sim.timer[1].dtmr &= ~(0x2);
   sim.timer[1].dtcn = 0x0;
   sim.timer[1].dter = 0x3;
#else
   sim.timer[1].tmr &= ~(0x2);
   sim.timer[1].tcn = 0x0;
   sim.timer[1].ter = 0x3;
#endif

}

